/*
 * Work under Copyright. Licensed under the EUPL.
 * See the project README.md and LICENSE.txt for more information.
 */

package net.dries007.tfc.world.classic;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.GuiCreateWorld;
import net.minecraft.server.MinecraftServer;
import net.minecraft.world.World;
import net.minecraft.world.WorldServer;
import net.minecraft.world.WorldType;
import net.minecraft.world.biome.BiomeProvider;
import net.minecraft.world.gen.IChunkGenerator;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

import net.dries007.tfc.client.gui.GuiCustomizeWorld;

/**
 * todo: spawn stuff, see worldevent.createspawn & worldProvider
 */
public class WorldTypeTFC extends WorldType
{
    public static final int SEALEVEL = 144;
    public static final int ROCKLAYER2 = 110;
    public static final int ROCKLAYER3 = 55;

    public WorldTypeTFC()
    {
        super("tfc_classic");
    }

    @Override
    public BiomeProvider getBiomeProvider(World world)
    {
        return new BiomeProviderTFC(world);
    }

    @Override
    public IChunkGenerator getChunkGenerator(World world, String generatorOptions)
    {
        return new ChunkGenTFC(world, generatorOptions);
    }

    @Override
    public int getMinimumSpawnHeight(World world)
    {
        return SEALEVEL; //todo
    }

    @Override
    public double getHorizon(World world)
    {
        return SEALEVEL; //todo
    }

    @Override
    public int getSpawnFuzz(WorldServer world, MinecraftServer server)
    {
        if (world.func_82736_K().func_82765_e("spawnRadius")) return world.func_82736_K().func_180263_c("spawnRadius");
        return ((ChunkGenTFC) world.func_72863_F().field_186029_c).s.spawnFuzz;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void onCustomizeButton(Minecraft mc, GuiCreateWorld guiCreateWorld)
    {
        mc.func_147108_a(new GuiCustomizeWorld(guiCreateWorld, guiCreateWorld.field_146334_a));
    }

    @Override
    public boolean isCustomizable()
    {
        return true;
    }

    @Override
    public float getCloudHeight()
    {
        return 2 * SEALEVEL;
    }
}
